<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class RelImpostoProdutoService {

	public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
        
    }
  
	public function buscaDados($cdfilial, $dtinicial, $dtfinal, $produtoinicial, $produtofinal, $cdcaixa, $cdimposto, $nrorg, $idrelatorio) {

		$params = array(
     	":CDFILIAL" => (is_array($cdfilial)  && count($cdfilial) != 0) ? $cdfilial : "",
     	":CDCAIXA" => (is_array($cdcaixa)  && count($cdcaixa) != 0) ? implode('_' ,$cdcaixa) : "",
     	":CDIMPOSTO" => (is_array($cdimposto)  && count($cdimposto) != 0) ? implode('_' ,$cdimposto) : "",
     	":CDPRODINI" => $produtoinicial,
     	":CDPRODFIM" => $produtofinal,
     	":DTVENDAINI" => $dtinicial,
     	":DTVENDAFIN" => $dtfinal,
     	":CDPRODUTO" => null,
     	":TCDPRODUTO" => (is_array($produtoinicial)  && count($produtoinicial) != 0) ? "N" : "T",
     	":TCDFILIAL" => (is_array($cdfilial)  && count($cdfilial) != 0) ?  "N" : "T",
     	":TCDCAIXA" => (is_array($cdcaixa)  && count($cdcaixa) != 0) ?  "N" : "T",
     	":TCDIMPOSTO" => (is_array($cdimposto)  && count($cdimposto) != 0) ?  "N" : "T",
     	":NRORG" => $nrorg
 		);
 		$params = $this->nivelMaxProduto($params);
 		ini_set('memory_limit', '3G');
 		
 		switch($idrelatorio){
 			case 0:
 				$response = $this->entityManager->getConnection()->fetchAll(self::BUSCA_REL_IMPOSTO_PRODUTO, $params);
				for ($i = 0; $i < count($response); $i++) {
					$params[':CDPRODUTO'] = $response[$i]['CDPRODUTO'];
				 	$response[$i]['TOTALVEND']  = (float)$response[$i]['TOTALVEND'];
				 	if($response[$i]['IDTPEMISVEND'] == 'E'){
						$pisConfins = $this->entityManager->getConnection()->fetchAll(self::BUSCA_PIS_CONFINS_IMPOSTO_PRODUTO, $params);
				 		if($pisConfins){
					 		$response[$i]['VRIMPPIS'] = $pisConfins['PIS'];
					 		$response[$i]['VRIMPCOFINS'] = $pisConfins['CONFINS'];
				 		} else {
				 			$response[$i]['VRIMPPIS'] = 0;        
					 		$response[$i]['VRIMPCOFINS'] = 0;	
				 		}	
				 	}
				 }
			    return $response;
			    break;
			    
			case 1:
				$response = $this->entityManager->getConnection()->fetchAll(self::BUSCA_REL_IMPOSTO_CUPOM_FISCAL, $params);
				return $response;
				break;
				
			case 2:
				$response = [];
				$filialArray = $this->entityManager->getConnection()->fetchAll(self::BUSCA_FILIAL_REL_IMPOSTO_PRODUTO_GERAL, $params);
		 	    foreach ($filialArray as $filial) {
		 	     	$params[':CDFILIAL'] = $filial['CDFILIAL'];
		 			  $dataGeral = $this->entityManager->getConnection()->fetchAll(self::BUSCA_REL_IMPOSTO_PRODUTO_GERAL, $params);
		 	     	$imposto = $this->entityManager->getConnection()->fetchAll(self::BUSCA_IMPOSTO_REL_IMPOSTO_PRODUTO_GERAL, $params);
		 	     	for($i = 0; count($dataGeral) > $i; $i++){
		 	     		if ($dataGeral[$i]['CDFILIAL'] == $filial['CDFILIAL']){
				 	     	foreach ($imposto as $imp){
				 	     		$dataGeral[$i]['LABELFILIAL'] = 	$dataGeral[$i]['LABELFILIAL'].$imp['SGIMPOSTO'].": ".number_format($imp['VRIMPOPRODIT'], 2)." | ";
				 	     	}
		 	    			array_push($response, $dataGeral[$i]);
		 	     		}
		 	     	}
		 	     }
				 for ($i = 0; $i < count($response); $i++) {
				 	$response[$i]['TOTALVEND']  = (float)$response[$i]['TOTALVEND'];
				 	$response[$i]['VRUNITVEND'] = $response[$i]['VRUNITVEND'];
				 }
			 	 return $response;
			 	 break;
			 	 
			case 3: 
				$response = $this->entityManager->getConnection()->fetchAll(self::BUSCA_REL_IMPOSTO_SAT, $params);
	 			return $response;
	 			break;
	 			
			case 4:
				$response = $this->entityManager->getConnection()->fetchAll(self::BUSCA_REL_IMPOSTO_NFCESAT, $params);
	 			return $response;
	 			break;
 		}
		
	}
	
	private function nivelMaxProduto($params){
	  $nivelMaxProduto = $this->entityManager->getConnection()->fetchAll(self::BUSCA_NIVEL_MAX_PRODUTO);
	  if(!empty($params[':CDPRODINI']) && !empty($params[':CDPRODFIM'])){ 
	      $tamanhoCDPRODFIM = strlen($params[':CDPRODFIM']);
	      if($tamanhoCDPRODFIM < $nivelMaxProduto[0]['TAMCOMPLETO']){
	        $params[':CDPRODFIM'] = str_pad($params[':CDPRODFIM'], $nivelMaxProduto[0]['TAMCOMPLETO'], "9", STR_PAD_RIGHT);
	      }
	  }
		return $params;
	}
	
	const BUSCA_NIVEL_MAX_PRODUTO = "SELECT LENGTH(MIN(CDARVPROD)) TAMCOMPLETO, CDNVPRODUTO
                                  FROM PRODUTO
                                  WHERE CDNVPRODUTO = (SELECT MAX(CDNVPRODUTO) FROM PRODUTO)
                                  GROUP BY CDNVPRODUTO";
	
	const BUSCA_REL_IMPOSTO_PRODUTO = "  
      SELECT VE.CDFILIAL, F.NMFILIAL, VE.IDTPEMISVEND, PR.NMPRODUTO, VE.CDFILIAL || ' - ' || F.NMFILIAL AS LABELFILIAL,
             SUM(IT.QTPRODVEND) AS QTPRODVEND, PR.SGUNIDADE, PR.CDARVPROD, PR.CDARVPROD || ' - ' || PR.NMPRODUTO AS CDNMPRODUTO, 
             II.CDIMPOSTO, I.SGIMPOSTO, II.VRPEALPRODIT, 
             TRUNC(SUM((TRUNC(IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0)),2) + NVL(IT.VRACRITVEND,0) - NVL(IT.VRDESITVEND,0)) * II.VRPEALPRODIT / 100),2) AS VRIMPOPRODIT,
             SUM(TRUNC(IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0)),2) - NVL(IT.VRDESITVEND ,0) + NVL(IT.VRACRITVEND,0)) AS TOTALVEND,
             IT.CDPRODUTO, SUM(II.VRIMPPIS) AS VRIMPPIS, SUM(II.VRIMPCOFINS) AS VRIMPCOFINS  
      FROM VENDA VE, ITEMVENDA IT, ITVENDAIMPOS II, PRODUTO PR, FILIAL F, IMPOSTO I, 
       (SELECT DISTINCT CDFILIAL, NMFILIAL, CDLOJA, CDCAIXA 
        FROM V_FILIALLOJACAIXA FLC
        WHERE (((INSTR(:CDFILIAL, FLC.CDFILIAL) <> 0) OR (:TCDFILIAL = 'T'))
          AND ((INSTR(:CDCAIXA, FLC.CDFILIAL||FLC.CDCAIXA) <> 0) OR (:TCDCAIXA = 'T')))
        ) FLC
      WHERE VE.CDCAIXA = FLC.CDCAIXA
        AND VE.CDFILIAL = FLC.CDFILIAL
        AND ((INSTR(:CDIMPOSTO, II.CDIMPOSTO) <> 0) OR (:TCDIMPOSTO = 'T'))
        AND ( (:TCDPRODUTO = 'T') OR (PR.CDARVPROD BETWEEN :CDPRODINI AND :CDPRODFIM))
        AND (VE.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN)
        AND (VE.IDSITUVENDA = 'O')
        AND (VE.NRORG = :NRORG)
        AND (IT.NRORG = VE.NRORG)
        AND (PR.NRORG = VE.NRORG)
        AND (F.NRORG = VE.NRORG)
        AND (I.NRORG = VE.NRORG)
        AND (II.NRORG = VE.NRORG)
        AND (IT.CDFILIAL = VE.CDFILIAL)
        AND (IT.CDCAIXA = VE.CDCAIXA)
        AND (IT.NRSEQVENDA = VE.NRSEQVENDA)
        AND (IT.CDFILIAL = II.CDFILIAL)
        AND (IT.CDCAIXA = II.CDCAIXA)
        AND (IT.NRSEQVENDA = II.NRSEQVENDA)
        AND (IT.NRSEQUITVEND = II.NRSEQUITVEND)
        AND (II.CDIMPOSTO = I.CDIMPOSTO)
        AND (PR.CDPRODUTO = IT.CDPRODUTO)
        AND (F.CDFILIAL = VE.CDFILIAL)
      GROUP BY VE.CDFILIAL, F.NMFILIAL, VE.IDTPEMISVEND, PR.CDARVPROD, PR.NMPRODUTO, II.CDIMPOSTO, I.SGIMPOSTO, II.VRPEALPRODIT,
            PR.SGUNIDADE, IT.CDPRODUTO
      ORDER BY VE.CDFILIAL, SUM(IT.QTPRODVEND) DESC, II.CDIMPOSTO, PR.CDARVPROD,PR.NMPRODUTO
    ";
    const BUSCA_PIS_CONFINS_IMPOSTO_PRODUTO = "
    
    SELECT NVL(A.COFINS,0) AS COFINS, NVL(B.PIS,0) AS PIS 
    FROM 
     (SELECT ((IP.VRALIQIT /100)* IP.VRPRODUTO) AS COFINS
        FROM ITEMVENOUTIMPOS IP , IMPOSTO I
       WHERE (((INSTR(:CDFILIAL, IP.CDFILIAL) <> 0) OR (:TCDFILIAL = 'T'))
          AND ((INSTR(:CDCAIXA, IP.CDFILIAL||IP.CDCAIXA) <> 0) OR (:TCDCAIXA = 'T')))
           AND IP.CDPRODUTO  = :CDPRODUTO
           AND (IP.DTREDUCAOZ BETWEEN :DTVENDAINI AND :DTVENDAFIN)
           AND I.SGIMPOSTO = 'COFINS'
           AND I.NRORG = :NRORG 
           AND IP.NRORG = :NRORG
           AND I.CDIMPOSTO = IP.CDIMPOSTO) A,
       
     (SELECT ((IP.VRALIQIT /100)* IP.VRPRODUTO) AS PIS
        FROM ITEMVENOUTIMPOS IP , IMPOSTO I
       WHERE (((INSTR(:CDFILIAL, IP.CDFILIAL) <> 0) OR (:TCDFILIAL = 'T'))
          AND ((INSTR(:CDCAIXA, IP.CDFILIAL||IP.CDCAIXA) <> 0) OR (:TCDCAIXA = 'T')))
           AND IP.CDPRODUTO  = :CDPRODUTO
           AND (IP.DTREDUCAOZ BETWEEN :DTVENDAINI AND :DTVENDAFIN)
           AND I.SGIMPOSTO = 'PIS'
           AND I.NRORG = :NRORG 
           AND IP.NRORG = :NRORG
           AND I.CDIMPOSTO = IP.CDIMPOSTO) B
      ";
      
 const BUSCA_REL_IMPOSTO_CUPOM_FISCAL = "
  SELECT VE.CDFILIAL||' - '||F.NMFILIAL AS LABELFILIAL, TC.NRECFTURCAIX||' - Nr.Cupom Fiscal: '|| (CASE 
    WHEN VE.IDTPEMISVEND = 'E' THEN VE.NRCUPOMFIS ELSE VE.NRNOTAFISCALCE END)|| ' Data Venda: '|| VE.DTVENDA AS LABELCUPOM,
    VE.CDFILIAL, F.NMFILIAL, TC.NRECFTURCAIX, VE.DTVENDA, PR.CDARVPROD, PR.NMPRODUTO, PR.CDARVPROD || ' - ' || PR.NMPRODUTO AS CDNMPRODUTO, 
    (CASE WHEN VE.IDTPEMISVEND = 'E' THEN VE.NRCUPOMFIS ELSE VE.NRNOTAFISCALCE END) AS NRCUPOMFIS, SUM(IT.QTPRODVEND) AS QTPRODVEND,
    PR.SGUNIDADE, IT.VRUNITVEND, II.CDIMPOSTO, I.SGIMPOSTO, II.VRPEALPRODIT, 
    TRUNC(SUM((TRUNC(IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0)),2) + NVL(IT.VRACRITVEND,0) - NVL(IT.VRDESITVEND,0)) * II.VRPEALPRODIT / 100),2) AS VRIMPOPRODIT,
    SUM(TRUNC(IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0)),2) - NVL(IT.VRDESITVEND ,0) + NVL(IT.VRACRITVEND,0)) AS TOTALVEND
  FROM VENDA VE, TURCAIXA TC, ITEMVENDA IT, ITVENDAIMPOS II, PRODUTO PR, FILIAL F, IMPOSTO I
  WHERE ((INSTR(:CDFILIAL, VE.CDFILIAL) <> 0) OR (:TCDFILIAL = 'T'))
    AND ((INSTR(:CDCAIXA, VE.CDFILIAL||VE.CDCAIXA) <> 0) OR (:TCDCAIXA = 'T'))
    AND ((:TCDPRODUTO = 'T') OR (PR.CDARVPROD BETWEEN :CDPRODINI AND :CDPRODFIM))
    AND ((INSTR(:CDIMPOSTO, II.CDIMPOSTO) <> 0) OR (:TCDIMPOSTO = 'T'))
    AND (VE.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN)
    AND (VE.IDSITUVENDA = 'O'  )
    AND (TC.CDFILIAL = VE.CDFILIAL)
    AND (TC.CDCAIXA = VE.CDCAIXA)
    AND (TC.DTABERCAIX = VE.DTABERTUR)
    AND (IT.CDFILIAL = VE.CDFILIAL)
    AND (IT.CDCAIXA = VE.CDCAIXA)
    AND (IT.NRSEQVENDA = VE.NRSEQVENDA)
    AND (IT.CDFILIAL = II.CDFILIAL)
    AND (IT.CDCAIXA = II.CDCAIXA)
    AND (IT.NRSEQVENDA = II.NRSEQVENDA)
    AND (IT.NRSEQUITVEND = II.NRSEQUITVEND)
    AND (II.CDIMPOSTO = I.CDIMPOSTO)
    AND (PR.CDPRODUTO = IT.CDPRODUTO)
    AND (F.CDFILIAL = VE.CDFILIAL)
    AND (VE.NRORG = :NRORG)
    AND (TC.NRORG = VE.NRORG)
    AND (IT.NRORG = VE.NRORG)
    AND (II.NRORG = VE.NRORG)
    AND (PR.NRORG = VE.NRORG)
    AND (F.NRORG = VE.NRORG)
    AND (I.NRORG = VE.NRORG)
  GROUP BY VE.CDFILIAL, F.NMFILIAL,  TC.NRECFTURCAIX, VE.IDTPEMISVEND, VE.NRCUPOMFIS, VE.NRNOTAFISCALCE, VE.DTVENDA,
    PR.CDARVPROD, PR.NMPRODUTO, PR.SGUNIDADE, IT.VRUNITVEND, II.CDIMPOSTO, I.SGIMPOSTO, II.VRPEALPRODIT
  
  UNION ALL
  
  SELECT VE.CDFILIAL||' - '||F.NMFILIAL AS LABELFILIAL, 
    TC.NRECFTURCAIX||' - Nr.Cupom Fiscal:'||VE.NRNOTAFISCALCE|| ' Data Venda: '|| VE.DTVENDA AS LABELCUPOM,
    VE.CDFILIAL, F.NMFILIAL, TC.NRECFTURCAIX, VE.DTVENDA,PR.CDARVPROD, PR.NMPRODUTO, PR.CDARVPROD || ' - ' || PR.NMPRODUTO AS CDNMPRODUTO, VE.NRNOTAFISCALCE AS NRCUPOMFIS, 
    SUM(IT.QTPRODVEND) AS QTPRODVEND, PR.SGUNIDADE, IT.VRUNITVEND, '50' AS CDIMPOSTO, 'PIS' AS SGIMPOSTO, II.VRPERPIS AS VRPEALPRODIT,
    SUM((TRUNC(IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0)),2) + NVL(IT.VRACRITVEND,0) - NVL(IT.VRDESITVEND,0)) * II.VRPERPIS / 100) AS VRIMPOPRODIT,
    SUM(TRUNC(IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0)),2) - NVL(IT.VRDESITVEND ,0) + NVL(IT.VRACRITVEND,0)) AS TOTALVEND
  FROM VENDA VE, TURCAIXA TC, ITEMVENDA IT, ITVENDAIMPOS II, PRODUTO PR, FILIAL F, IMPOSTO I
  WHERE ((INSTR(:CDFILIAL, VE.CDFILIAL) <> 0) OR (:TCDFILIAL = 'T'))
    AND ((INSTR(:CDCAIXA, VE.CDFILIAL||VE.CDCAIXA) <> 0) OR (:TCDCAIXA = 'T'))
    AND ((:TCDPRODUTO = 'T') OR (PR.CDARVPROD BETWEEN :CDPRODINI AND :CDPRODFIM))
    AND ((INSTR(:CDIMPOSTO, '50') <> 0) OR (:TCDIMPOSTO = 'T'))
    AND (VE.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN)
    AND (VE.IDSITUVENDA = 'O')
    AND (VE.IDTPEMISVEND IN ('S','N'))
    AND (TC.CDFILIAL = VE.CDFILIAL)
    AND (TC.CDCAIXA = VE.CDCAIXA)
    AND (TC.DTABERCAIX = VE.DTABERTUR)
    AND (IT.CDFILIAL = VE.CDFILIAL)
    AND (IT.CDCAIXA = VE.CDCAIXA)
    AND (IT.NRSEQVENDA = VE.NRSEQVENDA)
    AND (IT.CDFILIAL = II.CDFILIAL)
    AND (IT.CDCAIXA = II.CDCAIXA)
    AND (IT.NRSEQVENDA = II.NRSEQVENDA)
    AND (IT.NRSEQUITVEND = II.NRSEQUITVEND)
    AND (II.CDIMPOSTO = I.CDIMPOSTO)
    AND (PR.CDPRODUTO = IT.CDPRODUTO)
    AND (F.CDFILIAL = VE.CDFILIAL)
    AND (VE.NRORG = :NRORG)
    AND (TC.NRORG = VE.NRORG)
    AND (IT.NRORG = VE.NRORG)
    AND (II.NRORG = VE.NRORG)
    AND (PR.NRORG = VE.NRORG)
    AND (F.NRORG = VE.NRORG)
    AND (I.NRORG = VE.NRORG)
  GROUP BY VE.CDFILIAL, F.NMFILIAL,  TC.NRECFTURCAIX, VE.NRNOTAFISCALCE, VE.DTVENDA, PR.CDARVPROD, PR.NMPRODUTO,
    PR.SGUNIDADE, IT.VRUNITVEND, II.VRPERPIS
  
  UNION ALL
  
  SELECT VE.CDFILIAL || ' - ' || F.NMFILIAL AS LABELFILIAL,
    TC.NRECFTURCAIX || ' - Nr.Cupom Fiscal:' || VE.NRNOTAFISCALCE || ' Data Venda: ' || VE.DTVENDA AS LABELCUPOM,
    VE.CDFILIAL, F.NMFILIAL,TC.NRECFTURCAIX, VE.DTVENDA, PR.CDARVPROD, PR.NMPRODUTO, PR.CDARVPROD || ' - ' || PR.NMPRODUTO AS CDNMPRODUTO, VE.NRNOTAFISCALCE AS NRCUPOMFIS,  
    SUM(IT.QTPRODVEND) AS QTPRODVEND, PR.SGUNIDADE, IT.VRUNITVEND, '60' AS CDIMPOSTO, 'COFINS' AS SGIMPOSTO, II.VRPERCOFINS AS VRPEALPRODIT,
    SUM((TRUNC(IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0)),2) + NVL(IT.VRACRITVEND,0) - NVL(IT.VRDESITVEND,0)) * II.VRPERCOFINS / 100) AS VRIMPOPRODIT,
    SUM(TRUNC(IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0)),2) - NVL(IT.VRDESITVEND ,0) + NVL(IT.VRACRITVEND,0)) AS TOTALVEND
  FROM VENDA VE, TURCAIXA TC, ITEMVENDA IT, ITVENDAIMPOS II, PRODUTO PR, FILIAL F, IMPOSTO I
  WHERE ((INSTR(:CDFILIAL, VE.CDFILIAL) <> 0) OR (:TCDFILIAL = 'T'))
    AND ((INSTR(:CDCAIXA, VE.CDFILIAL||VE.CDCAIXA) <> 0) OR (:TCDCAIXA = 'T'))
    AND ((:TCDPRODUTO = 'T') OR (PR.CDARVPROD BETWEEN :CDPRODINI AND :CDPRODFIM))
    AND ((INSTR(:CDIMPOSTO, '60') <> 0) OR (:TCDIMPOSTO = 'T'))
    AND (VE.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN)
    AND (VE.IDSITUVENDA = 'O')
    AND (VE.IDTPEMISVEND IN ('S','N'))
    AND (TC.CDFILIAL = VE.CDFILIAL)
    AND (TC.CDCAIXA = VE.CDCAIXA)
    AND (TC.DTABERCAIX = VE.DTABERTUR)
    AND (IT.CDFILIAL = VE.CDFILIAL)
    AND (IT.CDCAIXA = VE.CDCAIXA)
    AND (IT.NRSEQVENDA = VE.NRSEQVENDA)
    AND (IT.CDFILIAL = II.CDFILIAL)
    AND (IT.CDCAIXA = II.CDCAIXA)
    AND (IT.NRSEQVENDA = II.NRSEQVENDA)
    AND (IT.NRSEQUITVEND = II.NRSEQUITVEND)
    AND (II.CDIMPOSTO = I.CDIMPOSTO)
    AND (PR.CDPRODUTO = IT.CDPRODUTO)
    AND (F.CDFILIAL = VE.CDFILIAL)
    AND (VE.NRORG = :NRORG)
    AND (TC.NRORG = VE.NRORG)
    AND (IT.NRORG = VE.NRORG)
    AND (II.NRORG = VE.NRORG)
    AND (PR.NRORG = VE.NRORG)
    AND (F.NRORG = VE.NRORG)
    AND (I.NRORG = VE.NRORG)
  GROUP BY VE.CDFILIAL, F.NMFILIAL,  TC.NRECFTURCAIX, VE.NRNOTAFISCALCE, VE.DTVENDA, PR.CDARVPROD, PR.NMPRODUTO,
    PR.SGUNIDADE, IT.VRUNITVEND, II.VRPERCOFINS
  ORDER BY QTPRODVEND DESC, CDARVPROD";
  
  const BUSCA_REL_IMPOSTO_SAT = "
  SELECT FI.CDFILIAL,
       FI.NMFILIAL,
       VE.CDCAIXA, 
       VE.CDCAIXA || ' - ' || 'Nr. Cupom/Nota: ' || DECODE(VE.IDTPEMISVEND,'E', VE.NRCUPOMFIS, VE.NRNOTAFISCALCE)   AS LABELCAIXA,
       FI.CDFILIAL || ' - ' || FI.NMFILIAL AS LABELFILIAL,
       PR.CDARVPROD || ' - ' || PR.NMPRODUTO AS CDNMPRODUTO,
       DECODE(VE.IDTPEMISVEND,'E', VE.NRCUPOMFIS, VE.NRNOTAFISCALCE) AS NRNOTAFISCALCE,
       VE.NRACESSONFCE, 
       PR.CDARVPROD,
       PR.NMPRODUTO,
       PR.SGUNIDADE,       
       IT.QTPRODVEND,
       TRUNC((IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0))),2) - NVL(IT.VRDESITVEND ,0) + NVL(IT.VRACRITVEND,0) AS VRPRODVEN,
       NVL(II.VRBASECALCREDUZ,0) AS VRBASECALCREDUZ,
       TRUNC((IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0))),2) - NVL(IT.VRDESITVEND ,0) + NVL(IT.VRACRITVEND,0) AS VRBCICMS,
       II.VRPEALPRODIT,       
       DECODE(VE.IDTPEMISVEND,'N',TRUNC((TRUNC((IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0))),2) + NVL(IT.VRACRITVEND,0) - NVL(IT.VRDESITVEND,0)) * II.VRPEALPRODIT / 100,2),
                                  ROUND((TRUNC((IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0))),2) + NVL(IT.VRACRITVEND,0) - NVL(IT.VRDESITVEND,0)) * II.VRPEALPRODIT / 100,2)) AS VRICMS,
       II.CDCFOPPROD,
       TRUNC((IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0))),2) - NVL(IT.VRDESITVEND ,0) + NVL(IT.VRACRITVEND,0) AS VRBCPIS,
       II.VRPERPIS,       
       DECODE(VE.IDTPEMISVEND,'N',TRUNC((TRUNC((IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0))),2) - NVL(IT.VRDESITVEND ,0) + NVL(IT.VRACRITVEND,0)) * II.VRPERPIS / 100,2),
                                  ROUND((TRUNC((IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0))),2) - NVL(IT.VRDESITVEND ,0) + NVL(IT.VRACRITVEND,0)) * II.VRPERPIS / 100,2)) AS VRPIS,       
       TRUNC((IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0))),2) - NVL(IT.VRDESITVEND ,0) + NVL(IT.VRACRITVEND,0) AS VRBCCOFINS,
       II.VRPERCOFINS,
       DECODE(VE.IDTPEMISVEND,'N',TRUNC((TRUNC((IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0))),2) - NVL(IT.VRDESITVEND ,0) + NVL(IT.VRACRITVEND,0)) * II.VRPERCOFINS / 100,2),
                                  ROUND((TRUNC((IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0))),2) - NVL(IT.VRDESITVEND ,0) + NVL(IT.VRACRITVEND,0)) * II.VRPERCOFINS / 100,2)) AS VRCOFINS, 
       IT.VRACRITVEND       
  FROM VENDA VE, ITEMVENDA IT, ITVENDAIMPOS II, PRODUTO PR, FILIAL FI
 WHERE VE.CDFILIAL = II.CDFILIAL
   AND VE.CDCAIXA  = II.CDCAIXA
   AND VE.NRSEQVENDA = II.NRSEQVENDA
   AND IT.CDFILIAL = II.CDFILIAL
   AND IT.CDCAIXA  = II.CDCAIXA
   AND IT.NRSEQVENDA = II.NRSEQVENDA
   AND IT.NRSEQUITVEND = II.NRSEQUITVEND
   AND IT.CDPRODUTO = PR.CDPRODUTO
   AND FI.CDFILIAL = VE.CDFILIAL  
   AND VE.IDSITUVENDA = 'O'
-- AND VE.IDTPEMISVEND IN ('S','N')
   AND VE.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN   
   AND (VE.NRORG = :NRORG)
   AND (IT.NRORG = VE.NRORG)
   AND (II.NRORG = VE.NRORG)
   AND (PR.NRORG = VE.NRORG)
   AND (FI.NRORG = VE.NRORG)
   AND ((INSTR(:CDFILIAL , VE.CDFILIAL ) <> 0) OR (:TCDFILIAL = 'T'))
   AND ((INSTR(:CDCAIXA  , VE.CDFILIAL||VE.CDCAIXA ) <> 0) OR (:TCDCAIXA = 'T'))
   AND ((INSTR(:CDIMPOSTO, II.CDIMPOSTO ) <> 0) OR (:TCDIMPOSTO = 'T'))
   AND ((:TCDPRODUTO = 'T') OR (PR.CDARVPROD BETWEEN :CDPRODINI AND :CDPRODFIM))
ORDER BY VE.CDFILIAL, VE.CDCAIXA, VE.NRNOTAFISCALCE
  ";
  
  const BUSCA_FILIAL_REL_IMPOSTO_PRODUTO_GERAL = "
  SELECT DISTINCT (VE.CDFILIAL) CDFILIAL
  FROM VENDA VE, ITVENDAIMPOS II, ITEMVENDA IT, PRODUTO PR
  WHERE ((INSTR(:CDFILIAL, VE.CDFILIAL) <> 0) OR (:TCDFILIAL = 'T'))
    AND ((INSTR(:CDCAIXA, VE.CDFILIAL||VE.CDCAIXA) <> 0) OR (:TCDCAIXA = 'T'))
    AND (VE.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN)
    AND ((INSTR(:CDPRODUTO, PR.CDARVPROD) <> 0) OR (:TCDPRODUTO = 'T') OR (PR.CDARVPROD BETWEEN :CDPRODINI AND :CDPRODFIM))
    AND ((INSTR(:CDIMPOSTO, II.CDIMPOSTO) <> 0) OR (:TCDIMPOSTO = 'T'))
    AND (VE.IDSITUVENDA = 'O')
    AND (VE.CDFILIAL = IT.CDFILIAL)
    AND (VE.CDCAIXA = IT.CDCAIXA )
    AND (VE.NRORG = :NRORG)
    AND (IT.NRORG = VE.NRORG)
    AND (PR.NRORG = VE.NRORG)
    AND (II.NRORG = VE.NRORG)
    AND (VE.NRSEQVENDA = IT.NRSEQVENDA)
    AND (IT.CDFILIAL = II.CDFILIAL)
    AND (IT.CDCAIXA = II.CDCAIXA )
    AND (IT.NRSEQVENDA = II.NRSEQVENDA)
    AND (IT.NRSEQUITVEND = II.NRSEQUITVEND)
    AND (IT.CDPRODUTO = PR.CDPRODUTO)
  "; 
  const BUSCA_IMPOSTO_REL_IMPOSTO_PRODUTO_GERAL = "
  SELECT 
    VE.CDFILIAL, II.CDIMPOSTO, I.SGIMPOSTO, 
    SUM((TRUNC(IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0)),2) + NVL(IT.VRACRITVEND,0) - NVL(IT.VRDESITVEND,0)) * II.VRPEALPRODIT / 100) AS VRIMPOPRODIT
  FROM 
    VENDA VE, TURCAIXA TC, ITEMVENDA IT, ITVENDAIMPOS II, PRODUTO PR, FILIAL F, IMPOSTO I
  WHERE VE.CDFILIAL = :CDFILIAL
    AND ((INSTR(:CDCAIXA, VE.CDFILIAL||VE.CDCAIXA) <> 0) OR (:TCDCAIXA = 'T'))
    AND ((INSTR(:CDIMPOSTO, II.CDIMPOSTO) <> 0) OR (:TCDIMPOSTO = 'T'))
    AND ((INSTR(:CDPRODUTO, PR.CDARVPROD) <> 0) OR (:TCDPRODUTO = 'T') OR (PR.CDARVPROD BETWEEN :CDPRODINI AND :CDPRODFIM))
    AND (VE.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN)
    AND (VE.IDSITUVENDA = 'O')
    AND (TC.CDFILIAL = VE.CDFILIAL)
    AND (TC.CDCAIXA = VE.CDCAIXA)
    AND (TC.DTABERCAIX = VE.DTABERTUR)
    AND (IT.CDFILIAL = VE.CDFILIAL)
    AND (IT.CDCAIXA = VE.CDCAIXA)
    AND (IT.NRSEQVENDA = VE.NRSEQVENDA)
    AND (IT.CDFILIAL = II.CDFILIAL)
    AND (IT.CDCAIXA = II.CDCAIXA)
    AND (IT.NRSEQVENDA = II.NRSEQVENDA)
    AND (IT.NRSEQUITVEND = II.NRSEQUITVEND)
    AND (II.CDIMPOSTO = I.CDIMPOSTO)
    AND (PR.CDPRODUTO = IT.CDPRODUTO)
    AND (F.CDFILIAL = VE.CDFILIAL)
    AND (VE.NRORG = :NRORG)
    AND (TC.NRORG = VE.NRORG)
    AND (IT.NRORG = VE.NRORG)
    AND (II.NRORG = VE.NRORG)
    AND (PR.NRORG = VE.NRORG)
    AND (F.NRORG = VE.NRORG)
    AND (I.NRORG = VE.NRORG)
  GROUP BY 
    VE.CDFILIAL, II.CDIMPOSTO, I.SGIMPOSTO
  ORDER BY VE.CDFILIAL, II.CDIMPOSTO, I.SGIMPOSTO
    ";
  
  const BUSCA_REL_IMPOSTO_PRODUTO_GERAL = "
    SELECT VE.CDFILIAL, F.NMFILIAL, VE.CDFILIAL || ' - ' || F.NMFILIAL || ' | ' AS LABELFILIAL, TC.NRECFTURCAIX, VE.NRCUPOMFIS, VE.DTVENDA,
      PR.CDARVPROD, PR.NMPRODUTO, PR.CDARVPROD || ' - ' || PR.NMPRODUTO AS CDNMPRODUTO, SUM(IT.QTPRODVEND) AS QTPRODVEND,
      PR.SGUNIDADE, IT.VRUNITVEND,II.CDIMPOSTO, I.SGIMPOSTO, II.VRPEALPRODIT, 
      SUM((TRUNC(IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0)),2) + NVL(IT.VRACRITVEND,0) - NVL(IT.VRDESITVEND,0)) * II.VRPEALPRODIT / 100) AS VRIMPOPRODIT,
      SUM(TRUNC(IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0)),2) - NVL(IT.VRDESITVEND ,0) + NVL(IT.VRACRITVEND,0)) AS TOTALVEND
    FROM VENDA VE, TURCAIXA TC, ITEMVENDA IT, ITVENDAIMPOS II, PRODUTO PR, FILIAL F, IMPOSTO I
    WHERE ((INSTR(:CDFILIAL, VE.CDFILIAL) <> 0) OR (:TCDFILIAL = 'T'))
      AND ((INSTR(:CDCAIXA, VE.CDFILIAL||VE.CDCAIXA) <> 0) OR (:TCDCAIXA = 'T'))
      AND ((INSTR(:CDPRODUTO, PR.CDARVPROD) <> 0) OR (:TCDPRODUTO = 'T') OR (PR.CDARVPROD BETWEEN :CDPRODINI AND :CDPRODFIM))
      AND ((INSTR(:CDIMPOSTO, II.CDIMPOSTO) <> 0) OR (:TCDIMPOSTO = 'T'))
      AND (VE.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN)
      AND (VE.IDSITUVENDA = 'O')
      AND (TC.CDFILIAL = VE.CDFILIAL)
      AND (TC.CDCAIXA = VE.CDCAIXA)
      AND (TC.DTABERCAIX = VE.DTABERTUR)
      AND (IT.CDFILIAL = VE.CDFILIAL)
      AND (IT.CDCAIXA = VE.CDCAIXA)
      AND (IT.NRSEQVENDA = VE.NRSEQVENDA)
      AND (IT.CDFILIAL = II.CDFILIAL)
      AND (IT.CDCAIXA = II.CDCAIXA)
      AND (IT.NRSEQVENDA = II.NRSEQVENDA)
      AND (IT.NRSEQUITVEND = II.NRSEQUITVEND)
      AND (II.CDIMPOSTO = I.CDIMPOSTO)
      AND (PR.CDPRODUTO = IT.CDPRODUTO)
      AND (F.CDFILIAL = VE.CDFILIAL)
      AND (VE.NRORG = :NRORG)
      AND (TC.NRORG = VE.NRORG)
      AND (IT.NRORG = VE.NRORG)
      AND (PR.NRORG = VE.NRORG)
      AND (F.NRORG = VE.NRORG)
      AND (I.NRORG = VE.NRORG)
      AND (II.NRORG = VE.NRORG)
    GROUP BY VE.CDFILIAL, F.NMFILIAL, TC.NRECFTURCAIX, VE.NRCUPOMFIS, VE.DTVENDA, PR.CDARVPROD, PR.NMPRODUTO, PR.SGUNIDADE, 
      IT.VRUNITVEND, II.CDIMPOSTO, I.SGIMPOSTO, II.VRPEALPRODIT
    ORDER BY VE.CDFILIAL, QTPRODVEND DESC, TC.NRECFTURCAIX, VE.DTVENDA, VE.NRCUPOMFIS, II.CDIMPOSTO, PR.CDARVPROD
";

const BUSCA_REL_IMPOSTO_NFCESAT = "
	SELECT FI.CDFILIAL, FI.NMFILIAL, PR.CDARVPROD, FI.CDFILIAL || ' - ' || FI.NMFILIAL AS LABELFILIAL, 
    PR.CDARVPROD || ' - ' || PR.NMPRODUTO AS NMPRODUTO, PR.SGUNIDADE, SUM(IT.QTPRODVEND) AS QTPRODVEND, II.VRPEALPRODIT, II.VRPERPIS,
    II.VRPERCOFINS,
    SUM(TRUNC((IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0))),2) - NVL(IT.VRDESITVEND ,0) + NVL(IT.VRACRITVEND,0)) AS VRPRODVEN,
    SUM(NVL(II.VRBASECALCREDUZ,0)) AS VRBASECALCREDUZ,
    SUM(TRUNC((IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0))),2) - NVL(IT.VRDESITVEND ,0) + NVL(IT.VRACRITVEND,0)) AS VRBCICMS,
    SUM(DECODE(VE.IDTPEMISVEND,'N',TRUNC((TRUNC((IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0))),2) + NVL(IT.VRACRITVEND,0) - NVL(IT.VRDESITVEND,0)) * II.VRPEALPRODIT / 100,2),
                                    ROUND((TRUNC((IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0))),2) + NVL(IT.VRACRITVEND,0) - NVL(IT.VRDESITVEND,0)) * II.VRPEALPRODIT / 100,2))) AS VRICMS,
    SUM(TRUNC((IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0))),2) - NVL(IT.VRDESITVEND ,0) + NVL(IT.VRACRITVEND,0)) AS VRBCPIS,
    SUM(DECODE(VE.IDTPEMISVEND,'N',TRUNC((TRUNC((IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0))),2) - NVL(IT.VRDESITVEND ,0) + NVL(IT.VRACRITVEND,0)) * II.VRPERPIS / 100,2),
                                    ROUND((TRUNC((IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0))),2) - NVL(IT.VRDESITVEND ,0) + NVL(IT.VRACRITVEND,0)) * II.VRPERPIS / 100,2))) AS VRPIS,       
    SUM(TRUNC((IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0))),2) - NVL(IT.VRDESITVEND ,0) + NVL(IT.VRACRITVEND,0)) AS VRBCCOFINS,
    SUM(DECODE(VE.IDTPEMISVEND,'N',TRUNC((TRUNC((IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0))),2) - NVL(IT.VRDESITVEND ,0) + NVL(IT.VRACRITVEND,0)) * II.VRPERCOFINS / 100,2),
                                    ROUND((TRUNC((IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0))),2) - NVL(IT.VRDESITVEND ,0) + NVL(IT.VRACRITVEND,0)) * II.VRPERCOFINS / 100,2))) AS VRCOFINS
  FROM VENDA VE, ITEMVENDA IT, ITVENDAIMPOS II, PRODUTO PR, FILIAL FI
  WHERE (VE.CDFILIAL = II.CDFILIAL)
    AND (VE.CDCAIXA  = II.CDCAIXA)
    AND (VE.NRSEQVENDA = II.NRSEQVENDA)
    AND (IT.CDFILIAL = II.CDFILIAL)
    AND (IT.CDCAIXA  = II.CDCAIXA)
    AND (IT.NRSEQVENDA = II.NRSEQVENDA)
    AND (IT.NRSEQUITVEND = II.NRSEQUITVEND)
    AND (IT.CDPRODUTO = PR.CDPRODUTO)
    AND (FI.CDFILIAL = VE.CDFILIAL  )
    AND (VE.IDTPAMBNFCE = '1')
    AND (VE.IDSITUVENDA = 'O')
    AND (VE.IDTPEMISVEND IN ('S','N'))
    AND (VE.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN)
    AND ((INSTR(:CDFILIAL , VE.CDFILIAL ) <> 0) OR (:TCDFILIAL = 'T'))
    AND ((INSTR(:CDCAIXA  , VE.CDFILIAL||VE.CDCAIXA ) <> 0) OR (:TCDCAIXA = 'T'))
    AND ((:TCDIMPOSTO = 'T'))
    AND ((:TCDPRODUTO = 'T'))
    AND (VE.NRORG = :NRORG)
    AND (IT.NRORG = VE.NRORG)
    AND (II.NRORG = VE.NRORG)
    AND (PR.NRORG = VE.NRORG)
    AND (FI.NRORG = VE.NRORG)
  GROUP BY FI.CDFILIAL, FI.NMFILIAL, PR.CDARVPROD, PR.NMPRODUTO, PR.SGUNIDADE, II.VRPEALPRODIT,
    II.VRPERPIS,II.VRPERCOFINS
  ORDER BY FI.CDFILIAL, QTPRODVEND DESC, PR.NMPRODUTO
  ";
  
}